
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Manage Spring Boot Logs with Elasticsearch, Logstash and Kibana / 憋错料</title>

    <meta name="description" content="Manage Spring Boot Logs with Elasticsearch, Logstash and Kibana 下载地址:https://www.elastic.co/downloads When time comes to deploy a new project, one often overlooked aspect is log management. ELK stack (Elasticsearch, Logstash, Kibana) is, among other things, a powerful and freely available log management solution.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Manage Spring Boot Logs with Elasticsearch, Logstash and Kibana</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>下载地址：https://www.elastic.co/downloads</p>
<p>When time comes to deploy a new project, one often overlooked aspect is log management. ELK stack (Elasticsearch, Logstash, Kibana) is, among other things, a powerful and freely available log management solution. In this article I will show you how to install and setup ELK and use it with default log format of a Spring Boot application.</p>
<p>For this guide, I‘ve setup a demo Spring Boot application with logging enabled and with Logstash configuration that will send log entries to Elasticsearch. Demo application is a simple&nbsp;<a href="https://github.com/knes1/todo" rel="external nofollow noreferrer">todo list</a>&nbsp;available&nbsp;<a href="https://github.com/knes1/todo" rel="external nofollow noreferrer">here</a>.</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAva25lczEuZ2l0aHViLmlvL2ltYWdlcy9FTEsuc3Zn.jpg" /></p>
<p>Application will store logs into a log file. Logstash will read and parse the log file and ship log entries to an Elasticsearch instance. Finally, we will use Kibana 4 (Elasticsearch web frontend) to search and analyze the logs.</p>
<h3>Step 1) Install Elasticsearch</h3>
<ul>
<li>Download elasticsearch zip file from&nbsp;<a href="https://www.elastic.co/downloads/elasticsearch" rel="external nofollow noreferrer">https://www.elastic.co/downloads/elasticsearch</a></li>
<li>Extract it to a directory (unzip it)</li>
<li>Run it (<code>bin/elasticsearch</code>&nbsp;or&nbsp;<code>bin/elasticsearch.bat</code>&nbsp;on Windows)</li>
<li>Check that it runs using&nbsp;<code>curl -XGET http://localhost:9200</code></li>
</ul>
<p>Here‘s how to do it (steps are written for OS X but should be similar on other systems):</p>
<pre><code>wget https://download.elastic.co/elasticsearch/elasticsearch/elasticsearch-1.7.1.zip
unzip elasticsearch-1.7.1.zip
cd elasticsearch-1.7.1
bin/elasticsearch
</code></pre>
<p>Elasticsearch should be running now. You can verify it‘s running using&nbsp;<code>curl</code>. In a separate terminal window execute a GET request to Elasticsearch‘s status page:</p>
<pre><code>curl -XGET http://localhost:9200
</code></pre>
<p>If all is well, you should get the following result:</p>
<pre><code>{
  "status" : 200,
  "name" : "Tartarus",
  "cluster_name" : "elasticsearch",
  "version" : {
    "number" : "1.7.1",
    "build_hash" : "b88f43fc40b0bcd7f173a1f9ee2e97816de80b19",
    "build_timestamp" : "2015-07-29T09:54:16Z",
    "build_snapshot" : false,
    "lucene_version" : "4.10.4"
  },
  "tagline" : "You Know, for Search"
}
</code></pre>
<h3>Step 2) Install Kibana 4</h3>
<ul>
<li>Download Kibana archive from&nbsp;<a href="https://www.elastic.co/downloads/kibana" rel="external nofollow noreferrer">https://www.elastic.co/downloads/kibana</a></p>
<ul>
<li>Please note that you need to download appropriate distribution for your OS, URL given in examples below is for OS X</li>
</ul>
</li>
<li>Extract the archive</li>
<li>Run it (<code>bin/kibana</code>)</li>
<li>Check that it runs by pointing the browser to the Kibana‘s WebUI</li>
</ul>
<p>Here‘s how to do it:</p>
<pre><code>wget https://download.elastic.co/kibana/kibana/kibana-4.1.1-darwin-x64.tar.gz
tar xvzf kibana-4.1.1-darwin-x64.tar.gz
cd kibana-4.1.1-darwin-x64
bin/kibana
</code></pre>
<p>Point your browser to&nbsp;<a href="http://localhost:5601/" rel="external nofollow noreferrer">http://localhost:5601</a>&nbsp;(if Kibana page shows up, we‘re good - we‘ll configure it later)</p>
<h3>Step 3) Install Logstash</h3>
<ul>
<li>Download Logstash zip from&nbsp;<a href="https://www.elastic.co/downloads/logstash" rel="external nofollow noreferrer">https://www.elastic.co/downloads/logstash</a></li>
<li>Extract it (unzip it)</li>
</ul>
<pre><code>wget https://download.elastic.co/logstash/logstash/logstash-1.5.3.zip
unzip logstash-1.5.3.zip
</code></pre>
<h3>Step 4) Configure Spring Boot‘s Log File</h3>
<p>In order to have Logstash ship log files to Elasticsearch, we must first configure Spring Boot to store log entries into a file. We will establish the following pipeline: Spring Boot App &rarr; Log File &rarr; Logstash &rarr; Elasticsearch. There are other ways of accomplishing the same thing, such as configuring logback to use TCP appender to send logs to a remote Logstash instance via TCP, and many other configurations. I prefer the file approach because it‘s simple, unobtrusive (you can easily add it to existing systems) and nothing will be lost/broken if for some reason Logstash stops working or if Elasticsearch dies.</p>
<p>Anyhow, let‘s configure Spring Boot‘s log file. The simplest way to do this is to configure log file name in&nbsp;<code>application.properties</code>. It‘s enough to add the following line:</p>
<pre><code>logging.file=application.log
</code></pre>
<p>Spring Boot will now log ERROR, WARN and INFO level messages in the&nbsp;<code>application.log</code>&nbsp;log file and will also rotate it as it reaches 10 Mb.</p>
<h3>Step 5) Configure Logstash to Understand Spring Boot‘s Log File Format</h3>
<p>Now comes the tricky part. We need to create Logstash config file. Typical Logstash config file consists of three main sections: input, filter and output. Each section contains plugins that do relevant part of the processing (such as file input plugin that reads log events from a file or elasticsearch output plugin which sends log events to Elasticsearch).</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAva25lczEuZ2l0aHViLmlvL2ltYWdlcy9sb2dzdGFzaC1jb25mLnN2Zw==.jpg" /></p>
<p>Input section defines from where Logstash will read input data - in our case it will be a file hence we will use a&nbsp;<code>file</code>&nbsp;plugin with&nbsp;<code>multiline</code><code>codec</code>, which basically means that our input file may have multiple lines per log entry.</p>
<h4>Input Section</h4>
<p>Here‘s the input section:</p>
<pre><code>input {
  file {
    type =&gt; "java"
    path =&gt; "/path/to/application.log"
    codec =&gt; multiline {
      pattern =&gt; "^%{YEAR}-%{MONTHNUM}-%{MONTHDAY} %{TIME}.*"
      negate =&gt; "true"
      what =&gt; "previous"
    }
  }
}
</code></pre>
<ul>
<li>We‘re using&nbsp;<code>file</code>&nbsp;plugin.</li>
<li><code>type</code>&nbsp;is set to&nbsp;<code>java</code>&nbsp;- it‘s just additional piece of metadata in case you will use multiple types of log files in the future.</li>
<li><code>path</code>&nbsp;is the absolute path to the log file. It must be absolute - Logstash is picky about this.</li>
<li>We‘re using&nbsp;<code>multiline</code>&nbsp;<code>codec</code>&nbsp;which means that multiple lines may correspond to a single log event,</li>
<li>In order to detect lines that should logically be grouped with a previous line we use a detection pattern:
<ul>
<li><code>pattern =&gt; "^%{YEAR}-%{MONTHNUM}-%{MONTHDAY} %{TIME}.*"</code>&nbsp;&rarr; Each new log event needs to start with date.</li>
<li><code>negate =&gt; "true"</code>&nbsp;&rarr; if it doesn‘t start with a date ...</li>
<li><code>what =&gt; "previous"</code>&nbsp;&rarr; ... then it should be grouped with a previous line.</li>
</ul>
</li>
</ul>
<p>File input plugin, as configured, will tail the log file (e.g. only read new entries at the end of the file). Therefore, when testing, in order for Logstash to read something you will need to generate new log entries.</p>
<h4>Filter Section</h4>
<p>Filter section contains plugins that perform intermediary processing on an a log event. In our case, event will either be a single log line or multiline log event grouped according to the rules described above. In the filter section we will do several things:</p>
<ul>
<li>Tag a log event if it contains a stacktrace. This will be useful when searching for exceptions later on.</li>
<li>Parse out (or grok, in logstash terminology) timestamp, log level, pid, thread, class name (logger actually) and log message.</li>
<li>Specified timestamp field and format - Kibana will use that later for time based searches.</li>
</ul>
<p>Filter section for Spring Boot‘s log format that aforementioned things looks like this:</p>
<pre><code>filter {
  #If log line contains tab character followed by ‘at‘ then we will tag that entry as stacktrace
  if [message] =~ "\tat" {
    grok {
      match =&gt; ["message", "^(\tat)"]
      add_tag =&gt; ["stacktrace"]
    }
  }

  #Grokking Spring Boot‘s default log format
  grok {
    match =&gt; [ "message",
               "(?&lt;timestamp&gt;%{YEAR}-%{MONTHNUM}-%{MONTHDAY} %{TIME})  %{LOGLEVEL:level} %{NUMBER:pid} --- \[(?&lt;thread&gt;[A-Za-z0-9-]+)\] [A-Za-z0-9.]*\.(?&lt;class&gt;[A-Za-z0-9#_]+)\s*:\s+(?&lt;logmessage&gt;.*)",
               "message",
               "(?&lt;timestamp&gt;%{YEAR}-%{MONTHNUM}-%{MONTHDAY} %{TIME})  %{LOGLEVEL:level} %{NUMBER:pid} --- .+? :\s+(?&lt;logmessage&gt;.*)"
             ]
  }

  #Parsing out timestamps which are in timestamp field thanks to previous grok section
  date {
    match =&gt; [ "timestamp" , "yyyy-MM-dd HH:mm:ss.SSS" ]
  }
}
</code></pre>
<p>Explanation:</p>
<ul>
<li><code>if [message] =~ "\tat"</code>&nbsp;&rarr; If message contains&nbsp;<code>tab</code>&nbsp;character followed by&nbsp;<code>at</code>&nbsp;(this is ruby syntax) then...</li>
<li>... use the&nbsp;<code>grok</code>&nbsp;plugin to tag stacktraces:
<ul>
<li><code>match =&gt; ["message", "^(\tat)"]</code>&nbsp;&rarr; when&nbsp;<code>message</code>&nbsp;matches beginning of the line followed by&nbsp;<code>tab</code>&nbsp;followed by&nbsp;<code>at</code>&nbsp;then...</li>
<li><code>add_tag =&gt; ["stacktrace"]</code>&nbsp;&rarr; ... tag the event with&nbsp;<code>stacktrace</code>&nbsp;tag.</li>
</ul>
</li>
<li>Use the&nbsp;<code>grok</code>&nbsp;plugin for regular Spring Boot log message parsing:
<ul>
<li>First pattern extracts timestamp, level, pid, thread, class name (this is actually logger name) and the log message.</li>
<li>Unfortunately, some log messages don‘t have logger name that resembles a class name (for example, Tomcat logs) hence the second pattern that will skip the logger/class field and parse out timestamp, level, pid, thread and the log message.</li>
</ul>
</li>
<li>Use&nbsp;<code>date</code>&nbsp;plugin to parse and set the event date:
<ul>
<li><code>match =&gt; [ "timestamp" , "yyyy-MM-dd HH:mm:ss.SSS" ]</code>&nbsp;&rarr;&nbsp;<code>timestamp</code>&nbsp;field (grokked earlier) contains the timestamp in the specified format</li>
</ul>
</li>
</ul>
<h4>Output Section</h4>
<p>Output section contains output plugins that send event data to a particular destination. Outputs are the final stage in the event pipeline. We will be sending our log events to stdout (console output, for debugging) and to Elasticsearch.</p>
<p>Compared to filter section, output section is rather straightforward:</p>
<pre><code>output {
  # Print each event to stdout, useful for debugging. Should be commented out in production.
  # Enabling ‘rubydebug‘ codec on the stdout output will make logstash
  # pretty-print the entire event as something similar to a JSON representation.
  stdout {
    codec =&gt; rubydebug
  }

  # Sending properly parsed log events to elasticsearch
  elasticsearch {
    host =&gt; "127.0.0.1"
  }
}
</code></pre>
<p>Explanation:</p>
<ul>
<li>We are using multiple outputs:&nbsp;<code>stdout</code>&nbsp;and&nbsp;<code>elasticsearch</code>.</li>
<li><code>stdout { ... }</code>&nbsp;&rarr;&nbsp;<code>stdout</code>&nbsp;plugin prints log events to standard output (console).
<ul>
<li><code>codec =&gt; rubydebug</code>&nbsp;&rarr; Pretty print events using JSON-like format</li>
</ul>
</li>
<li><code>elasticsearch { ... }</code>&nbsp;&rarr;&nbsp;<code>elasticsearch</code>&nbsp;plugin sends log events to Elasticsearch server.
<ul>
<li><code>host =&gt; "127.0.0.1"</code>&nbsp;&rarr; Hostname where Elasticsearch is located - in our case, localhost.</li>
</ul>
</li>
</ul>
<blockquote><p><strong>Update 5/9/2016:</strong>&nbsp;At the time of writing this update, the latest versions of Logstash‘s elasticsearch output plugin uses&nbsp;<code>hosts</code>&nbsp;configuration parameter instead of&nbsp;<code>host</code>&nbsp;which is shown in example above. New parameter takes an array of hosts (e.g. elasticsearch cluster) as value. In other words, if you are using the latest Logstash version, configure elasticsearch output plugin as follows:</p>
<pre><code>elasticsearch {
   hosts =&gt; ["127.0.0.1"]
}
</code></pre>
</blockquote>
<h4>Putting it all together</h4>
<p>Finally, the three parts - input, filter and output - need to be copy pasted together and saved into&nbsp;<code>logstash.conf</code>&nbsp;config file. Once the config file is in place and Elasticsearch is running, we can run Logstash:</p>
<pre><code>/path/to/logstash/bin/logstash -f logstash.conf
</code></pre>
<p>If everything went well, Logstash is now shipping log events to Elasticsearch.</p>
<h3>Step 6) Configure Kibana</h3>
<p>Ok, now it‘s time to visit the Kibana web UI again. We have started it in step 2 and it should be running at&nbsp;<a href="http://localhost:5601/" rel="external nofollow noreferrer">http://localhost:5601</a>.</p>
<p>First, you need to point Kibana to Elasticsearch index(s) of your choice. Logstash creates indices with the name pattern of logstash-YYYY.MM.DD. In Kibana Settings &rarr; Indices configure the indices:</p>
<ul>
<li>Index contains time-based events (select this option)</li>
<li>Use event times to create index names (select this option)</li>
<li>Index pattern interval: Daily</li>
<li>Index name or pattern: [logstash-]YYYY.MM.DD</li>
<li>Click on "Create Index"</li>
</ul>
<p>Now click on "Discover" tab. In my opinion, "Discover" tab is really named incorrectly in Kibana - it should be labeled as "Search" instead of "Discover" because it allows you to perform new searches and also to save/manage them. Log events should be showing up now in the main window. If they‘re not, then double check the time period filter in to right corner of the screen. Default table will have 2 columns by default: Time and _source. In order to make the listing more useful, we can configure the displayed columns. From the menu on the left select level, class and logmessage.</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAva25lczEuZ2l0aHViLmlvL2ltYWdlcy9kaXNjb3Zlci1raWJhbmE0LnBuZw==.jpg" /></p>
<p>Alright! You‘re now ready to take control of your logs using ELK stack and start customizing and tweaking your log management configuration. You can download the sample application used when writing this article from here:&nbsp;<a href="https://github.com/knes1/todo" rel="external nofollow noreferrer">https://github.com/knes1/todo</a>. It‘s already configured to write logs in a file and has the Logstash config as described above (although absolute paths will need to be tweaked in&nbsp;<code>logstash.conf</code>).</p>
<p>If you would like to search or follow your EL logs from command line, checkout&nbsp;<a href="http://knes1.github.io/blog/2016/2016-03-06-elktail-command-line-tool-for-tailing-and-querying-ELK-logs.html" rel="external nofollow noreferrer">Elktail</a>&nbsp;- a command line utility I‘ve created for accessing and tailng logs stored in EL.</p>
<p>As always, let me know if you have any question/comments or ideas in the comments section below.</p>
<p>http://knes1.github.io/blog/2015/2015-08-16-manage-spring-boot-logs-with-elasticsearch-kibana-and-logstash.html</p>
<h1><a href="http://www.cnblogs.com/ASPNET2008/p/5594479.html" rel="external nofollow noreferrer">spring mvc+ELK从头开始搭建日志平台</a></h1>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE1NTMxNTkzMi01MjkwMDcwODUuanBn.jpg" /></p>
<p>最近由于之前协助前公司做了点力所能及的事情，居然收到了一份贵重的端午礼物，是给我女儿的一个乐高积木，整个有7大包物件，我花了接近一天的时间一砖一瓦的组织起来，虽然很辛苦但是能够从过程中体验到乐趣。这次将分享从头搭建分布式日志系统，主要是在spring mvc上结合ELK套件实现（之前有些工作由于分工不同由不同的同事来完成，我只是在已经配置好的环境下做开发而已），包含如下这些技术点：</p>
<ul>
<li>spring mvc</li>
<li>logback</li>
<li>logstash</li>
<li>elasticsearch</li>
<li>kibana</li>
<li>redis</li>
</ul>
<p>来看下整体的架构图，这类架构非常容易解决当下分布式系统下的日志记录，查询以及分析困难的问题。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE2MDEwODY4Mi0xNjI5MjEzNDE1LnBuZw==.jpg" /></p>
<p>操作系统，IDE环境：</p>
<ul>
<li>eclipse</li>
<li>windows</li>
</ul>
<p>1：搭建spring mvc项目<br />    eclipse自带创建的dynamic web project是个空结构，没有任何配置，我们要想跑起来一个hello world的项目，还需要做些配置，比如创建程序文件，比如view,controller等等。<br />    spring tool suite可以帮助我们解决这个问题，它提供了spring mvc的项目模板，里面自带一个hello world的可启动的应用页面，在eclipse中可以很方便的以插件形式安装spring tool suit，安装好之后就可以创建了。<br />    这里需要注意的是不同版本的spring tool suite在创建时的菜单会有不同，我目前的菜单位于：</p>
<p>首先要选中spring标签：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE2NDQyMzYwNC05Njg3MDk3NDcucG5n.jpg" /></p>
<p>然后在File菜单下找：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE2MTIwNzc5Mi0yMTQ1MDUxMzE1LnBuZw==.jpg" /><br />    创建好之后，我们就可以直接在tomcat下运行了，不需要任何的其它操作，相对创建的dynamic web project要方便的多，不过通过这种模板创建的项目也有缺点：如果你喜欢新的一些依赖包，那么你需要手工去pom文件中去更新版本号为你想要的，还有可能会引入部分你暂时可能用不上的一些第三方包。下图是稍加修改的项目完成图，是一个标准的maven结构的spring mvc。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE2NDU0NDkxNy0xNjg2OTMyODI2LmpwZw==.jpg" /></p>
<p>2：redis安装<br />     由于我的是windows环境，所以相应的需要下载windows版本的redis:<br />     windows版：https://github.com/mythz/redis-windows<br />     下载下来解压，然后选择一个版本：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE2MTUxMzEyMC0xNTM0MTMzOTA3LnBuZw==.jpg" /></p>
<p>配置文件我只修改了一个：bind，它是用来绑定一个固定IP的，为什么要显示的去绑定一个IP呢？后面会介绍我遇到的问题。<br />     启动服务端：在redis/bin目录下执行：redis-server.exe redis.windows.conf即可启动</p>
<p>启动客户端：在redis/bin目录下执行：redis-cli.exe -h 127.0.0.1 -p 6379，在这个窗口可以通过一些redis命令再测试redis是否正常，比如get,set ,keys *等等。</p>
<p>3:ELK安装</p>
<p>在这个网站可以找到ELK最新版本：https://www.elastic.co/downloads,将elasticsearch,logstash,kibana这三个全部下载下来。</p>
<ul>
<li>配置elasticsearch</li>
</ul>
<p>大部分的配置都使用默认的，只是为了好标识我修改了cluster.name以及node.name，详细的参数可研究文档。然后直接在bin目录下运行elasticsearch.bat就可以启动了。</p>
<p>打开http://127.0.0.1:9200/就可以，看到如下信息就说明启动正常了。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE2MjMxMjgwNy05NjU4NzY0MjAuanBn.jpg" /><br />    还有很多插件可以安装，用来帮助我们查看监控elasticsearch，这里先安装head，命令行进入elasticsearch的目录，然后执行plugin install mobz/elasticsearch-head即可安装。</p>
<p>安装成功后打开http://127.0.0.1:9200/_plugin/head/</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE2MjQxMTQ0OC0xNzExNzczMjQzLmpwZw==.jpg" /></p>
<ul>
<li>配置logstash</li>
</ul>
<p>先看下logstash的架构设计以及与其它ELK的配合，本篇的data source就是redis，不涉及到filter，最终日志输出到elasticsearch中。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE2MjU0NTE2Ny04ODY1Mzc0NTYucG5n.jpg" /></p>
<p>这里我们只配置input以及output,需要注意的是不同版本的logstash在配置上也会略有不同，大家有兴趣可以进一步做下对比。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre>input {

    redis {
        data_type =&gt; "list"
        key =&gt; "logstash"
        host =&gt; "127.0.0.1"
        port =&gt; 6379
        threads =&gt; 5
        codec =&gt; "json"
    }
}
filter {

}
output {

    elasticsearch {
        hosts =&gt; ["127.0.0.1:9200"]
        index =&gt; "logstash-%{type}-%{+YYYY.MM.dd}"
        document_type =&gt; "%{type}"
        workers =&gt; 1
        flush_size =&gt; 20
        idle_flush_time =&gt; 1
        template_overwrite =&gt; true
    }
    stdout{}
}</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>然后在logstash目录下执行logstash -f etc/logstash.d/即可启动</p>
<ul>
<li>配置kinbana</p>
<ul>
<li>elasticesearch.url指向之前配置好的elasticsearch地址。</li>
<li>kinbna.index，这个是用来存储kibana自身的一些信息的。</li>
</ul>
</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE2Mjc0Mjk5NS0xNzgzNTY1NDE4LmpwZw==.jpg" /></p>
<ul>
<li>集成logback</li>
</ul>
<p>需要有一个记录日志的入口，将logback-classic引入进来，为了将日志传递给redis，需要配置一个logback-redis-appender，依赖如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre>&lt;!-- Logging --&gt;
        &lt;dependency&gt;
            &lt;groupId&gt;org.slf4j&lt;/groupId&gt;
            &lt;artifactId&gt;slf4j-api&lt;/artifactId&gt;
            &lt;version&gt;${org.slf4j-version}&lt;/version&gt;
        &lt;/dependency&gt;
         &lt;dependency&gt;
            &lt;groupId&gt;ch.qos.logback&lt;/groupId&gt;
            &lt;artifactId&gt;logback-classic&lt;/artifactId&gt;
            &lt;version&gt;${logback.version}&lt;/version&gt;
        &lt;/dependency&gt;

        &lt;!--logstash begin --&gt;
        &lt;dependency&gt;
            &lt;groupId&gt;com.cwbase&lt;/groupId&gt;
            &lt;artifactId&gt;logback-redis-appender&lt;/artifactId&gt;
            &lt;version&gt;1.1.3&lt;/version&gt;
            &lt;exclusions&gt;
                &lt;exclusion&gt;
                    &lt;groupId&gt;redis.clients&lt;/groupId&gt;
                    &lt;artifactId&gt;jedis&lt;/artifactId&gt;
                &lt;/exclusion&gt;
            &lt;/exclusions&gt;
        &lt;/dependency&gt;</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>配置logback.xml，key需要与logstash配置文件中配置的key相匹配。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre>&lt;appender name="LOGSTASH" class="com.cwbase.logback.RedisAppender"&gt;
        &lt;source&gt;logstashdemo&lt;/source&gt;
        &lt;type&gt;dev&lt;/type&gt;
        &lt;host&gt;127.0.0.1&lt;/host&gt;
        &lt;key&gt;logstash&lt;/key&gt;
        &lt;tags&gt;dev&lt;/tags&gt;
        &lt;mdc&gt;true&lt;/mdc&gt;
        &lt;location&gt;true&lt;/location&gt;
        &lt;callerStackIndex&gt;0&lt;/callerStackIndex&gt;
    &lt;/appender&gt;</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>在homecontroller中记录日志，slf4j由于完成了与logback完美集成，所以我们也不需要做任何转换类的配置即可实现日志记录。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE3MDQzMzkwMS04Njc2NjIzNjIuanBn.jpg" /><br />     前文中曾经提到在配置redis时，设置了bind属性，让其指定到一个固定的IP。如果不指定，在logstash连接redis会有问题，其中的原因有待后续进一步确认。</p>
<p>4:运行网站，查看日志</p>
<p>当redis，elasticsearch,logstash服务运行正常后，启动spring mvc，通过logger记录的日志就可以在kibana中方便的查看了。</p>
<p>测试logback是否已经将日志发送到redis，可以通过redis的命令来查看是否包含了配置的logstash这个key，还可以通过llen来判断日志是否在正常的递增。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE2NTMwMDU3My05OTg2ODg5MjUuanBn.jpg" /></p>
<p>如果上面都正常，再找开kibana的页面，第一次打开会提示创建索引规则，创建好之后就可以看到日志已经被采集到elasticsearch中了。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE2MzUyMjYwNC0yMDM0MTA5NTIuanBn.jpg" /></p>
<p>经过接近两天的研究，终于从0开始搭建成功了spring mvc+ELK的分布式日志管理平台，java平台的优势就是开源的产品多，可利用优秀插件也多，擅于去发倔还是可以很省事的做些比较优秀的项目的。虽然本篇只是一个练手入门文章，但有了开始就会有收获。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE3MDcxLzIwMTYwNi8xNzA3MS0yMDE2MDYxNzE2NDE0NTEwNC04MDQ1ODcwNjIuanBn.jpg" /></p>
<p>本文参考：</p>
<ul>
<li>http://os.51cto.com/art/201403/431103.htm</li>
<li>http://kibana.logstash.es</li>
<li>http://blog.csdn.net/kmtong/article/details/38920327</li>
<li>http://www.cnblogs.com/xing901022/p/4802822.html</li>
<li>http://blog.csdn.net/july_2/article/details/24481935</li>
<li>https://www.elastic.co/guide/en/kibana/current/getting-started.html</li>
</ul>
<p>http://www.cnblogs.com/ASPNET2008/p/5594479.html</p>
<p>http://www.oschina.net/translate/elasticsearch-getting-started</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 22:11:14 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Manage Spring Boot Logs with Elasticsearch, Logstash and Kibana的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3q2yWz4.html" rel="bookmark">使用Logstash同步数据至Elasticsearch，Spring Boot中集成Elasticsearch实现搜索</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				安装logstash.同步数据至ElasticSearch 为什么使用logstash来同步,CSDN上有一篇文章简要的分析了以下几种同步工具的优缺点:https://blog.csdn.net/laoyang360/article/details/51694519. 下面开始实践: 1. 下载Logstash安装包,需要注意版本与elasticsearch保持一致,windows系统下直接解压即可. 2.添加同步mysql数据库的配置,并将mysql连接驱动jar包放在指定的配置目录 注: 目			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lmbeZ3.html" rel="bookmark">CENTOS6&period;5安装日志分析ELK elasticsearch &plus; logstash &plus; redis &plus; kibana</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.日志平台的工作流程 多个独立的agent(Shipper)负责收集不同来源的数据,一个中心agent(Indexer)负责汇总和分析数据,在中心agent前的Broker(使用redis实现)作为缓冲区,中心agent后的ElasticSearch用于存储和搜索数据,前端的Kibana提供丰富的图表展示. Shipper表示日志收集,使用LogStash收集各种来源的日志数据,可以是系统日志.文件.redis.mq等等: Broker作为远程agent与中心agent之间的缓冲区,使用red			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4peqmVM.html" rel="bookmark">Spring Boot &plus; Elasticsearch</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				spring data elasticsearch elasticsearch 2.0.0.RELEASE 2.2.0 1.4.0.M1 1.7.3 1.3.0.RELEASE 1.5.2 1.2.0.RELEASE 1.4.4 1.1.0.RELEASE 1.3.2 1.0.0.RELEASE https://github.com/helloworldtang/spring-data-elasticsearch 1.None of the configured nodes are availa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4N6eg24.html" rel="bookmark">基于Spring Boot技术栈 博客系统企业级前后端实战 渐进式讲解&plus;Thymeleaf&plus;Elasticsearch&plus;多种数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1章 Spring Boot 简介讲解Spring Boot的项目背景,已经与其他技术框架(比如,Spring.SpringMVC.SpringCloud等)的关系.简单介绍下Spring Boot 整个生态系统1-1 _Spring Boot博客_课程导学1-2 -Spring Boot 是什么 第2章 开启 Spring Boot 的第一个 Web 项目通过 Spring Initializr 来快速初始化一个 Spring Boot 原型,方便学员来极速体验Spring Boot.本课程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vwBZ64.html" rel="bookmark">Spring Boot 与ElasticSearch</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.ElasticSearch 介绍 ? 开源的 ElasticSearch 是目前全文搜索引擎的首选,它是一个分布式搜索服务,提供Restful API,它可以快速地存储.搜索和分析海量数据.底层基于 Lucene,采用多 shard(分片)的方式保证数据安全,并且提供自动 resharding 的功能,github 等大型站点也是采用 ElasticSearch 作为其搜索服务. ? ElasticSearch 是面向文档的,它存储整个对象(文档),它使用 JSON 作为文档的序列化格式.一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vjGdZ3.html" rel="bookmark">How To Use Logstash and Kibana To Centralize Logs On CentOS 6</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接:https://www.digitalocean.com/community/tutorials/how-to-use-logstash-and-kibana-to-centralize-logs-on-centos-6 Introduction In this tutorial, we will go over the installation of Logstash 1.4.2 and Kibana 3, and how to configure them to gather an			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O7v9P3.html" rel="bookmark">搭建spring boot&plus;elasticsearch&plus;activemq服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目前时间是:2017-01-24 本文不涉及activemq的安装 需求 activemq实时传递数据至服务 elasticsearch做索引 对外开放查询接口 完成全文检索 环境 jdk:1.8 spirng boot:1.4.3.RELEASE elasticsearch:2.4.3 activemq:5.13.2 ES插件 head:版本好像无太大差别 能查数据就行 analysis-ik:1.10.3 search-guard-2:2.4.3.9 search-guard-ssl:2.4			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/417ZaO0.html" rel="bookmark">spring boot 集成logstash 日志</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.logstash 插件配置 logstash下config文件夹下添加 test.conf 文件内容: input{ tcp { mode =&gt; &quot;server&quot; host =&gt; &quot;0.0.0.0&quot; port =&gt; 4567 codec =&gt; json_lines } } output{ elasticsearch{ hosts=&gt;[&quot;127.0.0.1:9200&quot;] index =&gt; &quot;user			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZWDLJ4.html" rel="bookmark">spring boot 2&period;0 整合 elasticsearch NoNodeAvailableException</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址:spring boot 2.0 整合 elasticsearch NoNodeAvailableException 原文说的有点问题,下面贴出我的配置: 码云项目地址:https://gitee.com/11230595/springboot-elasticsearch elasticsearch.yml cluster.name: my-applicationnetwork.host: 0.0.0.0 http.port: 9200transport.tcp.port: 9300tr			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMmYDDM.html" rel="bookmark" class="title">BZOJ 3252 攻略 线段树</a>
					<div>
						题意:链接 方法:线段树 解析: 闲的随机的题. 看完题后看着好像挺简单的. 既然每个点的权值只会传子树,并且整个图是严格的一棵树,所以应该是跟dfs序有关. 然后去看数据范围. 尼玛HINT是什么鬼 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/P47VQD3.html" rel="bookmark" class="title">MySQL单表百万数据记录分页性能优化</a>
					<div>
						原文地址:http://www.cnblogs.com/lyroge/p/3837886.html MySQL单表百万数据记录分页性能优化 背景: 自己的一个网站,由于单表的数据记录高达了一百万条,造 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MywAxL3.html" rel="bookmark" class="title">基于Html5的智能家居手机客户端设计（一）&mdash;&mdash;找到openhab的rest</a>
					<div>
						今天开始我的毕业设计,基于HTML5的智能家居手机客户端设计.挑剔了好久,终于找到我可以使用国外开源项目智能家居核心,通过restful(我也不是很懂,毕竟我只是电子信息学院爱好网络). REST描述 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVYQZj4.html" rel="bookmark" class="title">Python中reshape的用法&quest;</a>
					<div>
						使用数组的reshape方法,可以创建一个改变了尺寸的新数组,原数组的shape保持不变: 1 &gt;&gt;&gt; a = np.array([1, 2, 3, 4]);b = np.array ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/418a8P3.html" rel="bookmark" class="title">启动mongoDB 以及常用操作命令</a>
					<div>
						nonsql    关系数据库 集合  表 文档 行 启动mongoDB之前首先手动创建存放MongoDB数据文件的目录,如e:\mongo_data 执行命令  mongod --dbpath=e: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGWWQM.html" rel="bookmark" class="title">vim修改配色方案</a>
					<div>
						先看看vim编辑器提供的色彩配置方案: 首先进入vim的color目录(/usr/share/vim72/colors,不同的系统目录不同,建议在-/建立.vim目录,然后在些目录里建立对应的文件夹和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dA7rw3.html" rel="bookmark" class="title">Python 文件I&sol;O</a>
					<div>
						本章只讲述所有基本的的I/O函数,更多函数请参考Python标准文档. 打印到屏幕 最简单的输出方法是用print语句,你可以给它传递零个或多个用逗号隔开的表达式.此函数把你传递的表达式转换成一个字符 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YXr9aM.html" rel="bookmark" class="title">就在支付宝、美团把商家搞疯的时候 百度钱包干了件对的事！</a>
					<div>
						支付宝与美团最近撕得热闹,由亲密盟友转脸变成敌人.有消息称,美团近日要求商户全面停用支付宝,否则提高商户的提成比例:而阿里巴巴则退出对&quot;新美大&quot;的投资,全力扶持&quot;口碑&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47Dvl9M.html" rel="bookmark" class="title">《内容生产向视频过渡：Facebook收购QuickFire意欲何为？》有感</a>
					<div>
						1月9日消息,Facebook周四表示,已收购位于加州圣迭戈的QuickFire Networks. 一.解决视频传输问题 QuickFire是一家开发视频内容发布设备和转码处理软件的创业公司, 其创 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NG7PoM.html" rel="bookmark" class="title">python脚本0b文件处理</a>
					<div>
						要处理的文件: 此处处理将00的数据干掉. 处理python脚本: 1 dir_fd = open('abc.yuv','rb+') 2 tmp_fd = open('tmp.yuv','wb+')  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NGbYoM.html" rel="bookmark" class="title">Volley网络请求框架简析&mdash;&mdash;Android网络请求框架（三）</a>
					<div>
						题记-- 人来到这个世界上,只有两件事情,生与死, 一件事完了,另一件事还急什么? 有缘而来,无缘而去, 识自本心,见自本性 不起妄缘,无心无为 自由自在,动静自如 冷暖自知,则是修行 1.初始化一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rzXXq3.html" rel="bookmark" class="title">iOS APP 密码保存到钥匙串</a>
					<div>
						我们在开放APP时,通常要把一些比较重要的用户信息保留到APP中,我们很多时候的做法是直接裸存到NSUserDefaults.这种做法的很明显的缺点是不够安全,以下我们将用代码封装一个类,把用户名账号 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vzxjZ3.html" rel="bookmark" class="title">2016031901 - ubuntu15&period;1安装驱动</a>
					<div>
						个人使用u盘安装的ubuntu15.1,安装后找不到无线,主要是驱动没有安装的问题. 解决方案如下: 01.wife无法找到 02.pool文件夹内都是驱动,我们需要的网络驱动也在内 03.网络驱动包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD8VJpM.html" rel="bookmark" class="title">Java开发进阶之路</a>
					<div>
						背景一 我接触Java开发已经一年多了了. 从刚开始生涩地接触语法,惹得编译器报各种语法错误:到接触OOD的思想,封装.继承.多态,懵懵懂懂地听说着它们:再到学习Web开发,想着这些也许并不重要,实际 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nyyv23.html" rel="bookmark" class="title">selenium测试（Java）-- 验证信息（八）</a>
					<div>
						1 package com.test.validationinfor; 2 3 import org.openqa.selenium.WebDriver; 4 import org.openqa.se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41wm6X0.html" rel="bookmark" class="title">运维硬件总结</a>
					<div>
						计算机硬件知识总结详解 服务器:1U是4.45cm,宽 29cm 19英寸,服务器的厚度用U来表示 互联网公司用的最多的品牌是戴尔.IBM.惠普服务器 电脑组成:主板.CPU.内存.磁盘.显卡.声卡等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K8mW93.html" rel="bookmark" class="title">Swift技术之如何在iOS 8下使用Swift设计一个自定义的输入法  （主要是NSLayoutConstraint 的使用）</a>
					<div>
						当前位置: &gt; Swift新手入门 &gt; Swift技术之如何在iOS 8下使用Swift设计一个自定义的输入法 时间:2014-09-10 16:49来源:未知 作者:啊成 举报 点击:5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWrG764.html" rel="bookmark" class="title">linux load</a>
					<div>
						us 用户空间占用CPU百分比 sy 内核空间占用CPU百分比 ni 用户进程空间内改变过优先级的进程占用CPU百分比 id 空闲CPU百分比 wa 等待输入输出的CPU时间百分比 hi 硬件中断 s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWr1Rr4.html" rel="bookmark" class="title">几种常用的设计模式（DHMENG1）</a>
					<div>
						设计模式之单例模式 在OC中当一个控制器要在多个地方用到时,将考虑用单例 同理在C++中,当一个类在多个场景中都会用上,且多个场景在这个类中都有值的传递时,用单例模式 比如游戏主角的一个背包可以写成单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4N1oYZ3.html" rel="bookmark" class="title">对表数据的基本操作</a>
					<div>
						--对日期的做法insert into wan values ('ktf',5000,to_date('1980-08-11 14:40:23 ','yyyy-mm-dd hh24:mi:ss')); ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
